unit hiSPI;

interface

uses Kol,Share,Windows,Debug;

type
	THISPI = class(TDebug)
   private
   Nb:integer; //     MISO  
   LSB,MSB:byte;//     
   MOSI:byte; //     
   public
          
	_event_onLSB_MOSI:THI_Event;
	_event_onMSB_MOSI:THI_Event;
	_event_onSCK:THI_Event;
    _event_onLSB_Data_SPI:THI_Event;
    _event_onMSB_Data_SPI:THI_Event;
   	_event_onLatch:THI_Event; //    595
	_event_onLoad:THI_Event; //    165
		     
    _data_DataSPI:THI_Event; //     SPI
    _data_DataMISO:THI_Event; //     MISO
            
    procedure _work_doSendMode0(var _Data:TData; Index:word);
    procedure _work_doSendMode1(var _Data:TData; Index:word);
    procedure _work_doSendMode2(var _Data:TData; Index:word);
    procedure _work_doSendMode3(var _Data:TData; Index:word);
    procedure ReadMISO(MISO:byte;Ni:integer);// MISO=    : Ni=       
    procedure WriteMOSI(Ni:integer);// MISO=    : Ni=       
	procedure PulseLoad();
	procedure PulseLatch();    
	procedure _var_MSB_Data(var _Data:TData; Index:word);	    //      
    procedure _var_LSB_Data(var _Data:TData; Index:word);     //    
    		
	property _prop_NbitMISO:integer write Nb;//      
 
  end;

implementation
//0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
procedure THISPI._work_doSendMode0;

var
i:integer;
MISO:byte;
begin
MOSI := ReadInteger(_Data,_data_DataSPI); //         DataSPI
PulseLoad(); //    	 
_hi_onEvent(_event_onSCK, 0); //  
              
	   for i := 0 to 7 do  //    
           begin 
           WriteMOSI(i); 
//=====   ===================		
		 _hi_onEvent(_event_onSCK, 1);
	     MISO := ReadInteger(_Data, _data_DataMISO); //      MISO
		 ReadMISO(MISO,i); //      		 		   
	     _hi_onEvent(_event_onSCK, 0);
//========================================		   
            end;
PulseLatch(); //    
_hi_onEvent(_event_onMSB_Data_SPI, MSB); //       
_hi_onEvent(_event_onLSB_Data_SPI, LSB); //      

end;
//111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
procedure THISPI._work_doSendMode1;
var
i:integer;
MISO:byte;
begin
 MOSI := ReadInteger(_Data,_data_DataSPI); //         DataSPI
PulseLoad(); //    	 
_hi_onEvent(_event_onSCK, 0); //  
              
	   for i := 0 to 7 do  //    
           begin 
          MISO := ReadInteger(_Data, _data_DataMISO); //      MISO
		 ReadMISO(MISO,i); //      	  		   
//=====   ===================		
		 _hi_onEvent(_event_onSCK, 1);
		 WriteMOSI(i);	 
		 _hi_onEvent(_event_onSCK, 0);
//========================================		   
            end;
PulseLatch(); //    
_hi_onEvent(_event_onMSB_Data_SPI, MSB); //       
_hi_onEvent(_event_onLSB_Data_SPI, LSB); //      
end;

//222222222222222222222222222222222222222222222222222222222222222222222222222222222
procedure THISPI._work_doSendMode2;
var
i:integer;
MISO:byte;
begin
 MOSI := ReadInteger(_Data,_data_DataSPI); //         DataSPI
PulseLoad(); //    	 
_hi_onEvent(_event_onSCK, 1);
              
	   for i := 0 to 7 do  //    
           begin 
        	 		   
//=====   ===================		
		 _hi_onEvent(_event_onSCK, 0);
		 MISO := ReadInteger(_Data, _data_DataMISO); //      MISO
		 ReadMISO(MISO,i); //      	 
		 _hi_onEvent(_event_onSCK, 1);
//========================================
		  WriteMOSI(i); 
            end;
PulseLatch(); //    
_hi_onEvent(_event_onMSB_Data_SPI, MSB); //       
_hi_onEvent(_event_onLSB_Data_SPI, LSB); //      

end;
//3333333333333333333333333333333333333333333333333333333333333333333333333
procedure THISPI._work_doSendMode3;
var
i:integer;
MISO:byte;
begin
 MOSI := ReadInteger(_Data,_data_DataSPI); //         DataSPI
PulseLoad(); //    	 
_hi_onEvent(_event_onSCK, 1);
              
	   for i := 0 to 7 do  //    
           begin
//=====   ===================		
		 _hi_onEvent(_event_onSCK, 0);
		 WriteMOSI(i);  
		 _hi_onEvent(_event_onSCK, 1);
//========================================		   
         MISO := ReadInteger(_Data, _data_DataMISO); //      MISO
		 ReadMISO(MISO,i); //      	 
		   end;
PulseLatch(); //    
_hi_onEvent(_event_onMSB_Data_SPI, MSB); //       
_hi_onEvent(_event_onLSB_Data_SPI, LSB); //      
end;
//==============================================================================
//======    ==============================================================
procedure THISPI.ReadMISO; //        LSB MSB
var i:integer;
begin
i := Ni;
         //   
		 if MISO and (1 shl Nb) <> 0 then LSB := LSB or (1 shl i); //   0
         if MISO and (1 shl Nb) = 0 then LSB := LSB and not (1 shl i); //   1
		 //   
         if MISO and (1 shl Nb) <> 0 then MSB := MSB or (1 shl (7-i));
         if MISO and (1 shl Nb) = 0 then MSB := MSB and not (1 shl (7-i));
end;
//==============================================================================
//======    ==============================================================
procedure THISPI.WriteMOSI; //        LSB MSB
var i:integer;
begin
i := Ni;
          //   
		 if MOSI and (1 shl i) <> 0 then _hi_onEvent(_event_onLSB_MOSI, 1);
         if MOSI and (1 shl i) = 0 then _hi_onEvent(_event_onLSB_MOSI, 0);
		 //   
         if MOSI and (1 shl (7-i)) <> 0 then _hi_onEvent(_event_onMSB_MOSI, 1);
         if MOSI and (1 shl (7-i)) = 0 then _hi_onEvent(_event_onMSB_MOSI, 0);	       
end;
//=================================================================================
procedure THISPI.PulseLoad;
begin
//=====   165  =======
_hi_onEvent(_event_onLoad, 0);
_hi_onEvent(_event_onLoad, 1);
//===================================
end;
procedure THISPI.PulseLatch;
begin
//=====   595  =======
_hi_onEvent(_event_onLatch, 0);
_hi_onEvent(_event_onLatch, 1);
//======================================
end;
//==========================================================================
procedure THISPI._var_MSB_Data;      //
begin dtInteger(_Data,MSB);end;    //
procedure THISPI._var_LSB_Data;      //
begin dtInteger(_Data,LSB);end;    //
//==========================================================================
end.
